#include "../../../lib/std.mi"

Function FadeIn(layer boba);
Function FadeOut(layer boba);

Global Layout Main, Options;

Class Button BobaButton;

Global BobaButton play, pause, next, back, stop, eject, eq, pl, repeat, shuffle, cross;
Global Layer playI, pauseI, nextI, backI, stopI, ejectI, plI, eqI, repeatIOn, repeatIOff, shuffleIOn, shuffleIOff, crossIOn, crossIOff;
Global Button bobaEnable;
Global int Fade;
Global double speed;

System.onScriptLoaded() {
	/*Containers*/
	Main = getContainer("Main").getLayout("Normal");
	Options = getContainer("Option").getLayout("Normal");
	
	/*Icons*/
	playI = main.findObject("play.icon");
	stopI = main.findObject("stop.icon");
	pauseI = main.findObject("pause.icon");
	nextI = main.findObject("next.icon");
	backI = main.findObject("back.icon");
	ejectI = main.findObject("eject.icon");
	plI = main.findObject("pl.icon");
	eqI = main.findObject("eq.icon");
	repeatIOn = main.findObject("repeat.icon.on");
	repeatIOff = main.findObject("repeat.icon.off");
	shuffleIOn = main.findObject("shuffle.icon.on");
	shuffleIOff = main.findObject("shuffle.icon.off");
	crossIOn = main.findObject("cross.icon.on");
	crossIOff = main.findObject("cross.icon.off");
	
	/*Buttons*/
	play = main.findObject("play");
	stop = main.findObject("stop");
	pause = main.findObject("pause");
	next = main.findObject("next");
	back = main.findObject("back");
	eject = main.findObject("eject");
	pl = main.findObject("pl");
	eq = main.findObject("eq");
	repeat = main.findObject("repeat");
	shuffle = main.findObject("shuffle");
	cross = main.findObject("cross");
	
	bobaEnable = options.findObject("boba.enabled");
	Fade = 0;
	speed = 0.5;
	
	bobaEnable.onActivate(System.getPrivateInt("Boba", "BobaButtonEnabled", 0));
	repeat.onActivate(repeat.getActivated());
	shuffle.onActivate(shuffle.getActivated());
	cross.onActivate(cross.getActivated());
}

BobaButton.onEnterArea() {
	if(Fade == 1) {
		if(BobaButton == play) FadeIn(playI);
		else if(BobaButton == stop) FadeIn(stopI);
		else if(BobaButton == pause) FadeIn(pauseI);
		else if(BobaButton == next) FadeIn(nextI);
		else if(BobaButton == back) FadeIn(backI);
		else if(BobaButton == eject) FadeIn(ejectI);
		else if(BobaButton == pl) FadeIn(plI);
		else if(BobaButton == eq) FadeIn(eqI);
		else if(BobaButton == repeat) { FadeIn(repeatIOn); FadeIn(repeatIOff); }
		else if(BobaButton == shuffle) { FadeIn(shuffleIOn); FadeIn(shuffleIOff); }
		else if(BobaButton == cross) { FadeIn(crossIOn); FadeIn(crossIOff); }

	}
}

BobaButton.onLeaveArea() {
	if(Fade == 1) {
		if(BobaButton == play) FadeOut(playI);
		else if(BobaButton == stop) FadeOut(stopI);
		else if(BobaButton == pause) FadeOut(pauseI);
		else if(BobaButton == next) FadeOut(nextI);
		else if(BobaButton == back) FadeOut(backI);
		else if(BobaButton == eject) FadeOut(ejectI);
		else if(BobaButton == pl) FadeOut(plI);
		else if(BobaButton == eq) FadeOut(eqI);
		else if(BobaButton == repeat) { FadeOut(repeatIOn); FadeOut(repeatIOff); }
		else if(BobaButton == shuffle) { FadeOut(shuffleIOn); FadeOut(shuffleIOff); }
		else if(BobaButton == cross) { FadeOut(crossIOn); FadeOut(crossIOff); }
	}
}

FadeIn(layer boba) {
	boba.setTargetA(255);
	boba.setTargetSpeed(speed);
	boba.goToTarget();
}

FadeOut(layer boba) {
	boba.setTargetA(0);
	boba.setTargetSpeed(speed);
	boba.goToTarget();
}

bobaEnable.onActivate(int Enable) {
	if(enable == 1) {
		FadeOut(playI);
		FadeOut(stopI);
		FadeOut(pauseI);
		FadeOut(nextI);
		FadeOut(backI);
		FadeOut(ejectI);
		FadeOut(plI);
		FadeOut(eqI);
		FadeOut(repeatIOn);
		FadeOut(repeatIOff);
		FadeOut(shuffleIOn);
		FadeOut(shuffleIOff);
		FadeOut(crossIOn);
		FadeOut(crossIOff);
		Fade = 1;
	}
	else if(enable == 0) {
		FadeIn(playI);
		FadeIn(stopI);
		FadeIn(pauseI);
		FadeIn(nextI);
		FadeIn(backI);
		FadeIn(ejectI);
		FadeIn(plI);
		FadeIn(eqI);
		FadeIn(repeatIOn);
		FadeIn(repeatIOff);
		FadeIn(shuffleIOn);
		FadeIn(shuffleIOff);
		FadeIn(crossIOn);
		FadeIn(crossIOff);
		Fade = 0;
	}
}

repeat.onActivate(int Enable) {
	if(enable == 1) {
		repeatIOn.show();
		repeatIOff.hide();
	}
	else if(enable == 0) {
		repeatIOn.hide();
		repeatIOff.show();
	}
}

shuffle.onActivate(int Enable) {
	if(enable == 1) {
		shuffleIOn.show();
		shuffleIOff.hide();
	}
	else if(enable == 0) {
		shuffleIOn.hide();
		shuffleIOff.show();
	}
}

cross.onActivate(int enable) {
	if(enable == 1) {
		crossIOn.show();
		crossIOFf.hide();
	}
	else if(enable == 0) {
		crossIOn.hide();
		crossIOff.show();
	}
}